/* This file contains some compile-time configuration options for MS Windows
 * systems.
 * Change the values below if you want anything other than the defaults.
 * For *nix systems, src/config.h is used, which is generated by
 * build.sh from src/config.h.in.
 */

#ifndef _CONFIG_H
#define _CONFIG_H

/* Directory where the UQM game data is located */
#define CONTENTDIR "../content"

/* Directory where game data will be stored */
//#define USERDIR "../userdata/"
#define USERDIR "%APPDATA%/uqm/"

/* Directory where supermelee teams will be stored */
#define MELEEDIR USERDIR "teams/"

/* Directory where save games will be stored */
#define SAVEDIR USERDIR "save/"

/* Directory where config files will be stored */
#define CONFIGDIR USERDIR

/* Define if words are stored with the most significant byte first */
#undef WORDS_BIGENDIAN

/* Defined if your system has strupr of its own */
#define HAVE_STRUPR

/* Defined if your system has stricmp of its own */
#define HAVE_STRICMP

/* Defined if your system has getopt.h */
#undef HAVE_GETOPT_H

#endif /* _CONFIG_H */

